<template>
  <AvatarDisplay v-if="avatar" :config="avatar" :title="title" />
  <PAvatar v-else :label="fallback" :title="title" />
</template>

<script lang="ts" setup>
import { injectStrict } from '@/injectStrict'
import { ResourcesKey } from '@/provided'
import type { User } from '@/api'
import { computed } from 'vue'
import { useI18n } from 'vue-i18n'
import { AvatarDisplay } from '.'

const props = defineProps<{
  userId: User['id']
}>()

const Resources = injectStrict(ResourcesKey)

const userWithAvatar = computed(
  () => Resources.getUserWithAvatar(props.userId).value
)

const { t } = useI18n()
const title = computed(
  () =>
    userWithAvatar.value.user.name ||
    userWithAvatar.value.user.email ||
    t('resource.user.unknown')
)
const fallback = computed(() => title.value?.charAt(0).toUpperCase() || '')

const avatar = computed(() => userWithAvatar?.value?.avatar)
</script>
